#include "GameDataStruct.h"
#include "tmath.h"
#include "GeometryMath.h"
#include <algorithm>
#include <functional>


static D2D_POSITION _StartPosForRoleArrayOfBetweenPosToPos;
static bool _CompareLengthForRoleArrayOfBetweenPosToPos(const HEX_POSITION pos1, const HEX_POSITION pos2 ) {
	// vZ\Ȍ`
	D2D_POSITION p1( pos1.x, pos1.y );
	D2D_POSITION p2( pos2.x, pos2.y );

	// Jn_eX̓_ւ̃xNg
	D2D_VECTOR v1 = p1 - _StartPosForRoleArrayOfBetweenPosToPos;
	D2D_VECTOR v2 = p2 - _StartPosForRoleArrayOfBetweenPosToPos;

	// 
	return v1.length() < v2.length();
}

// wbNX̂`_Ƃa_̊Ԃɂ`bṽACԂB
vector<int> RoleArrayOfBetweenPosToPos( HEX_POSITION pos1, HEX_POSITION pos2 ) {

	// lO[oϐɃRs[BŔr֐悤ɗp邽߁B
	_StartPosForRoleArrayOfBetweenPosToPos.x = pos1.x;
	_StartPosForRoleArrayOfBetweenPosToPos.y = pos1.y;

	vector<int> arrRoleArray;

	vector< HEX_POSITION > pos_array;

	// Q̍W傫ȋ`oB
	double posy_min = pos1.y <= pos2.y ? pos1.y : pos2.y;
	double posy_max = pos1.y >  pos2.y ? pos1.y : pos2.y;
	double posx_min = pos1.x <= pos2.x ? pos1.x : pos2.x;
	posx_min = posx_min - 2; // Ŝ߁AP`ɓB
	double posx_max = pos1.x >  pos2.x ? pos1.x : pos2.x;
	posx_max = posx_max + 2; // Ŝ߁A1E`ɓB

	for ( double y = posy_min; y <= posy_max; y++ ) {
		for ( double x = posx_min;  x <= posx_max; x++ ) {
			// Ysł
			y = roundst(y);
			x = rounds񕪂̈zt(x); // 0.5z

			if ( (int)y % 2 == 0 ) {
				// x3.5ƂȂ3.0ւƐ
				x = (int)x;
				pos_array.push_back( HEX_POSITION( x, y ) );

			// YłB
			} else {
				// YȂX2.5ȂǂłȂƃ_Ȃ̂ɐ0.5B

				// 0.5ŊƋɂȂƂƂ́AłB0.5𑫂B
				if ( int(x / 0.5) % 2 == 0 ) {
					x = x + 0.5;
				}

				pos_array.push_back( HEX_POSITION( x, y ) );
			}
		}
	}

	// |WVpos1̋Ń\[g
	std::sort(pos_array.begin(),pos_array.end(),_CompareLengthForRoleArrayOfBetweenPosToPos);//r֐w肵ă\[g

	// \[gꂽz𑖍
	for ( vector<HEX_POSITION>::iterator it = pos_array.begin(); it != pos_array.end(); it++ ) {

		// pos1ƓȂ玟
		if ( it->x == pos1.x && it->y == pos1.y ) {
			continue;
		}

		// pos2ƓȂ玟
		if ( it->x == pos2.x && it->y == pos2.y ) {
			continue;
		}

		// YW͂Ɩ邩ǂB
		int role = -1;
		if ( Is_FieldWar() ) {
			role = GetFieldHexRole( it->x, it->y );
		} else if ( Is_CastleWar() ) {
			role = GetCastleHexRole( it->x, it->y );
		}

		// ̍W͖ƂȂ΁c
		if ( role != -1 ) {
			// ƊY`bvȂ΁c
			if ( RectAndLine( it->x-0.6, it->y-0.6, it->x+0.6, it->y+0.6,  pos1.x, pos1.y, pos2.x, pos2.y) ) {
				arrRoleArray.push_back( role );
			}
		}
	}

	// ssŁA킯ȂA
	// RWƂĂB
	// s͂wW͐ɂ܂Ƃ߂B
	// s0.5܂ĂB

	return arrRoleArray;
}